/**
 * 对话框
 * date 2018-3-5
 */
;(function(){
	Vue.component('dialog-confirm', {
	  // 有效，因为是在正确的作用域内
	  template: 
	  	'<div class="view-dialog confirm">' +
				'<div class="v-cont">' +
					'<div class="v-header">{{confirm.title}}</div>' +
					'<div class="v-body">{{confirm.body}}</div>' +
					'<div class="v-footer b-border">' +
						'<button type="button" class="mui-btn" v-tap="{fn: closeHandler}">{{confirm.leftBtnText}}</button>' +
						'<button type="button" class="mui-btn" v-tap="{fn: closeHandler, name: 1}">{{confirm.rightBtnText}}</button>' +
					'</div>' +
				'</div>' +
			'</div>' 
	  ,
	  props: ['confirm'],
	  mounted: function(){
	  	var This = this;
	  	app.plusReady(function(){
	  		this.key.addEventListener('backbutton', function() {
		        This.closeHandler();
		    }, false);
	  	})
	  },
	  methods: {
	    closeHandler: function(val) {
	    
	    	this.$emit('confirm', val.name);
	    }
	  },
	})	
}());

