/**
 * 虚拟键盘
 * date 2018-1-18
 */
Vue.component('select-options', {
  // 有效，因为是在正确的作用域内
  template: '<div class="view-dialog view-select-options">'+
			'<ul class="s-opitions">' +
				'<li v-for="(home, index) in options" :key="home.payId" :class="{\'b-border\': index == 0}" v-tap="{fn: clickHandler, name: {id: home.payId, name: home.payName}}">{{home.payName}}</li>' +
				'<li><button v-tap="closeHandler">取消</button></li>' +
			'</ul>' +
		'</div>',
  props: ['options'],
  created: function(){
	this.number = '';
	
	if (this.income) {
		this.number = this.income.substr(1);	
	}
  },
  beforeUpdate: function(){
  },
  methods: {
    clickHandler: function (val) {
    	this.closeHandler();
    	this.$emit('change', val.name);
    },
    
    closeHandler: function() {
    	this.$emit('close');
    },
    stopPropagation: function(e){
    	e.stopPropagation();
    }
  },
})
