(function($,app){
	
	var progessBar = {};
	var intV = {t:null,p:0};
	var ui = {};
	var init = function(box,style){
		var html = [
		'<div id="progress" class="progress-pan" '+(style?'style="'+style+'"':'')+'>',
			'<div class="process-inner">',
				'<span class="process-bar">',
					'<img id="pbar" src="../images/spin.png" />',
				'</span>',
				'<span id="ptxt" class="process-pec">0%</span>',
			'</div>',
			'<div class="stips">',
				'<span class="fa fa-lock color-yellow"></span>',
				'<span class="fs-12"> 通过GeoTrust国际安全认证</span>',
			'</div>',
			'<div id="processTxt" class="process-txt">',
				'正在获正在验证账户...',
			'</div>',
		'</div>',
		'<div id="processMask" class="progress-mask"></div>'
		].join('');
		var phide = document.createElement('div');
		phide.id="progress-hide";
		phide.style.display="none";
		phide.innerHTML = html;
		box.appendChild(phide.children[0]);
		box.appendChild(phide.children[0]);
		ui = {
			progress : document.getElementById('progress'),
			processTxt : document.getElementById('processTxt'),
			pbar : document.getElementById('pbar'),
			ptxt : document.getElementById('ptxt'),
			processMask : document.getElementById('processMask')
		};
		var boxStyle = window.getComputedStyle(box, null)||box.currentStyle;
	    if(boxStyle) {
	    	ui.progress.style.top = boxStyle.paddingTop;
	    	ui.processMask.style.top = boxStyle.paddingTop;
	    }
	};
	var startProgess = function(){
		intV = {t:null,p:0};
		ui.progress.style.display = "block";
		ui.processMask.style.display = "block";
		ui.pbar.classList.add('spin');
		intV.t = window.setInterval(function(){
			var p = Math.floor(Math.random() * 3);
			intV.p += p;
			ptxt.innerText = intV.p +"%"; 
			if(intV.p>12) ui.processTxt.innerHTML = "正在加密传输数据...";
			if(intV.p>95) ui.processTxt.innerHTML = "正在加密传输数据...<br>即将查询成功...";
			if(intV.p>96) {
				window.clearInterval(intV.t);
				intV.t = null;
				return false;
			}
		},100);
	};
	var stopProgess = function(callback){
		window.clearInterval(intV.t);
		var lastt = 100-intV.p
		var stt = 2500/lastt;
		if(lastt>80) stt = 2800/lastt;
		else if(lastt>60) stt = 2600/lastt;
		else if(lastt>40) stt = 2400/lastt;
		else if(lastt>20) stt = 2200/lastt;
		else if(lastt>10) stt = 2000/lastt;
		else stt = 1500/lastt;
		intV.t = window.setInterval(function(){
			intV.p += 6;
			if(intV.p<=100) ui.ptxt.innerText = intV.p +"%";
			if(intV.p>12) ui.processTxt.innerHTML = "正在加密传输数据...";
			if(intV.p>95) ui.processTxt.innerHTML = "正在加密传输数据...<br>即将查询成功...";						
			if(intV.p>=100) {
				ui.pbar.classList.remove('spin');
				ui.processTxt.innerHTML = "查询成功!";
				window.clearInterval(intV.t);
				intV.t = null;
				setTimeout(function(){
					ui.progress.style.display = "none";
					ui.processMask.style.display = "none";
					return false;
				},100);
				if(callback){
					setTimeout(function(){
						callback();
						return false;
					},100);
				}
			}
		},stt);
	};
	var hideProgess = function(){
		ui.progress.style.display = "none";
		ui.processMask.style.display = "none";
		window.clearInterval(intV.t);
		intV = {t:null,p:0};
	};
	
	progessBar.intV = intV;
	progessBar.ui = ui;
	progessBar.init = init;
	progessBar.startProgess = startProgess;
	progessBar.stopProgess = stopProgess;
	progessBar.hideProgess = hideProgess;
	
	window.progessBar = progessBar;
	return progessBar;
})(mui,app);
