
var cacheOfficialInfo = null;
var bBtn = true;
app.mui.init({swipeBack:true});
new Vue({
	el: "#body",
	data:{
		cityData: {},
		paymentType: {isShow: false, options: [], value: ''},//类型
		inputVals: {},//提交的数据
		fields: [
		{"cityCode":"110000","type":"1","serialNumber":1,"paraValue":"account",
		"isDisplay": "1",
		"paraName":"社保卡帐号","paraPrompt":"社保卡官网账号","elementType":"text","elementValue":null},
		{"cityCode":"110000","type":"1","serialNumber":2,"paraValue":"password","paraName":"社保卡密码",
		"isDisplay": "1",
		"paraPrompt":"社保卡官网密码","elementType":"password","elementValue":null},
		{"cityCode":"110000","type":"1","serialNumber":3,"paraValue":"safeCode","paraName":"验证码",
		"isDisplay": "1",
		"elementType":"text","elementValue":'../images/yzm.gif'}
		],
		officialInfo: {},//提示内容和修改激活链接数据
		isSubmit: false,
		telData: {
			defaultText: '获取验证码',
			disabled: false,
			downCount: 60
		},
		warnTxt:"",//提示信息
		warnShow:false
	},
	created: function(){
		var This = this;
		this._getCityName();
		app.plusReady(function(){
			app.setBarStyle('light');
		})
	},
	mounted: function(){
		var This = this;

   		setTimeout(function(){
   			var offsetH = g("tipsCon").offsetHeight+60;
	   		if(offsetH>document.documentElement.clientHeight*0.8){
	   			g('modal').querySelector('.modal-box').style.height='80%';
	   			g('modal').querySelector('.mui-scroll-wrapper').style.position='absolute';
	   			g('modal').querySelector('.mui-scroll').style.position='absolute';
	   		}else{
	   			g('modal').querySelector('.modal-box').style.height='auto';
	   			g('modal').querySelector('.mui-scroll-wrapper').style.position='static';
	   			g('modal').querySelector('.mui-scroll').style.position='static';
	   		}
			g('loginQs').addEventListener('tap', function() {
				var btnRect = g('loginQs').getBoundingClientRect();
				var modalHeight = g('modal').querySelector('.modal-box').offsetHeight;
				var setTop = btnRect.top - modalHeight - 1;
				var maxTop = app.headerH;
				
				if(setTop<maxTop){
		   			g('modal').querySelector('.modal-box').classList.add('middle');
		   			g('modal').querySelector('.modal-box').style.top='50%';
		   		}else{
		   			g('modal').querySelector('.modal-box').classList.remove('middle');
					g('modal').querySelector('.modal-box').style.top= setTop+'px';
		   		}
		        g('modal').classList.add('mui-active');
		    });
		     mui('#modal').on('tap','#closeTips',function(){
		    	g('modal').classList.remove('mui-active');
		    	return false;
		    });
			mui('#modal .mui-scroll-wrapper').scroll().scrollTo(0,0);
   		}, 2000)
	    
	    
	    // 监听城市变化
	    app.addEventListener('changeCity', function(e){
	    	This._setCity(e);
	    })
	},
	methods: {
		_getCityName: function(){
			var city = app.getCity();
			this._setCity(city);
		},
		// 设置城市
		_setCity: function(city){
			this.cityData = city;
			this._getCityConfig(city.cityCode);		
		},
		_getCityConfig: function(cityCode){
			var This = this;
			shebaoSvc.getBindCardInfor(cityCode).then(function(data) {
				cacheOfficialInfo = data.officialInfo;//输入项数据和提示数据
				
				
				
				if (data.officialConfigList.length) {
					This.paymentType.isShow = false;
					data.officialConfigList[0].selected = true;
					This.paymentType.value = data.officialConfigList[0].officialCode;
					
					// 如果官网正在维护，提示
					This.promptStatus(data.officialConfigList, This.paymentType.value);
				}
				if(data.officialConfigList.length>1){
					This.paymentType.isShow = true;
					This.paymentType.options = data.officialConfigList;
				}
				
				if (cacheOfficialInfo) {
					This._setFields();
					This.officialInfo = cacheOfficialInfo[This.paymentType.value].cityInfo;
				}
					
				This.getSafeCode();
				
			}).catch(function(err){
				console.log(err)
				app.alert('此城市正在维护中，暂时不能登录，给您带来不便敬请谅解');
			});
			
		},
		/*验证是否官网在维护中*/
		promptStatus: function(officialConfigList, officialCode){
			var status = true;
			var msg = '';
			for(var i=0; i<officialConfigList.length;i++){
				var official = officialConfigList[i];
				if(officialCode===official.officialCode && official.officialStatus===2){ 
					msg = official.officialStatusMessage
					status = false;
					break;
				}
			}
			if(msg) app.toast(msg);
			return status;
		},
		/**
		 * 设置form field
		 */
		_setFields: function(src){
			var paraList = cacheOfficialInfo[this.paymentType.value].paraList;
			var tempArr = null;
			
			if (paraList.length == 0) {
				paraList = this.fields;//默认
			}
			this.fields = this._serialzerOfficialSaveCodeUrl(paraList, src ? src : '../images/yzm.gif');
			var result = [];
			//处理select的下拉数据的类型
			for(var i=0;i<this.fields.length;i++){
				if(this.fields[i].elementType==="select" && typeof this.fields[i].elementValue == 'string'){
					
					try {
						tempArr = JSON.parse(this.fields[i].elementValue);
					
						result = tempArr.map(function(val){
							
							for (var k in val) {
								
							}
							return {name: k, val: val[k]};
						})
						result.unshift({name: '请选择', val: ''});
						this.fields[i].elementValue = result;
					} catch (e) {
						console.log(e)
					} 
					break;
				}
			}
		},
		paymentChangeHandler: function(e){//更换社保类型
			var oSelect = e.target;
			var optVal = null;
			var index = oSelect.selectedIndex;
			var options = this.paymentType.options;
			
			for (var i = 0; i < options.length; i++) {
				options[i].selected = false;	
			}
			options[index].selected = true;
			this.paymentType.value = options[index].officialCode;
			this.getSafeCode();
			this._setFields();
		},
		getSafeCode: function(){//图片验证码
			var This  = this;
			if (!bBtn) return;
			bBtn = false;
			shebaoSvc.getSafeCode(this.paymentType.value).then(function (data) {
				This._setFields(data.saveCodePath);
				bBtn = true;
			}).catch(function (err) {
				console.error(err.message,err);
				bBtn = true;
				app.alert('连接社保管理中心失败');
			});
		},
		
		// 获取短信验证码
		getTelCode: function() {
			var This = this;
			var datasObj = {grabType: '0',telCodeType: '2'};//grabType 0-社保,1-公积金
			
			if (This.telData.disabled || !bBtn) return;
			bBtn = false;
			
			for ( var i = 0; i < This.fields.length; i ++) {
				
				if (This.fields[i].paraValue !== "phoneCode") {
					datasObj[This.fields[i].paraValue] = This.inputVals[This.fields[i].paraValue];
				}
				if (!This.inputVals[This.fields[i].paraValue] && This.fields[i].isDisplay === '1' && This.fields[i].paraValue!=="phoneCode") {
					app.toast(This.fields[i].paraName+'不能为空');
					bBtn = true;
					return;
				}	
			}
			datasObj.cityCode = This.cityData.cityCode;
			This.telData.defaultText = '发送中...';
			shebaoSvc.getTelcode(datasObj).then(function(data) {
				This._telCodeDownCount();
				bBtn = true;
			}).catch(function(err) {
				bBtn = true;
				app.alert(err.message);
				This.telData.defaultText = '获取验证码';
				This.getSafeCode();
				This.telData.disabled = false;

			});
		},
		areaChangeHandler: function(e){
			var target = e.target;
			this.inputVals[target.getAttribute('id')] = target.value;
		},
		// 短信倒计时
		_telCodeDownCount: function(){
			var This = this;
			down();
			function down(){
				This.telData.downCount --;
				This.telData.disabled = true;
				setTimeout(function(){
					
					if (This.telData.downCount > 0) {
						down();
					} else {
						This.telData.defaultText = '发送验证码';
						This.telData.disabled = false;
						This.telData.downCount = 60;
					}

				}, 1000)
			}
			
		},
		
		// 同意协议
		protocalChangeHandler: function(e){
			this.isSubmit = !this.isSubmit;
		},
		// 绑定公积金
		submitHandler: function(){
			var This = this;
			
			if (!This.isSubmit || !bBtn) return;
			bBtn = false;
			for ( var i = 0; i < This.fields.length; i ++) {
				
				if (!This.inputVals[This.fields[i].paraValue] && This.fields[i].isDisplay === '1') {
					app.toast(This.fields[i].paraName+'不能为空')
					bBtn = true;
					return;
				}	
			}
			
			This.inputVals.cityCode = This.paymentType.value;
			progessBar.init(document.querySelector('.mui-content'));
			progessBar.startProgess();
			shebaoSvc.bindSecurityCard(This.inputVals).then(function (data) {
				var user = app.getUser();
				if(user){
		            user.securityAcctId = data.securityAcctId;
		            app.setState('info',user);
	        	}
				progessBar.stopProgess(function(){
					 app.appRefresh();
			         app.openPage('securityDetail', {"securityAcctId":data.securityAcctId, "cityCode": This.cityData.cityCode});
			         setTimeout(function(){
				         var opener = plus.webview.currentWebview();
						 opener.hide();
						 opener.close();
			         }, 2000)
				});
				This._setDefaultCard(data.securityAcctId);
				bBtn = true;
			}).catch(function (err) {
				console.error(err.message,err);
				progessBar.hideProgess();
				bBtn = true;
				// 短信验证码错误除外重新获取图形验证码
				if (err.code !== '90008') {
					This.getSafeCode();	
				}
				app.alert(err.message);
			});
		},
		goPage: function(e) {
			var httpRE = /^http/;
			var url = e.url;
			if (httpRE.test(url)) {
				app.openUrl({url: url});
			} else {
				app.openPage(url, {type: 0});
			}
		},
		_serialzerOfficialSaveCodeUrl: function(officialList, src){
			var This = this;
			
			return Array.isArray(officialList) && officialList.map(function(val){
				if (val.paraValue == 'safeCode') {
					val.elementValue = src;
					This.inputVals[val.paraValue] = '';
				}
				return val;
			})
		},
		_setDefaultCard: function(accountId){
			shebaoSvc.changeDefaultAccount(accountId).then(function (data) {}).catch(function (err) {});
		}
	}
})

