/**
 * 地理定位失败
 * date 2018-1-20
 */
;(function(){
	Vue.component('local-notfind', {
	  // 有效，因为是在正确的作用域内
	  template: 
	  	'<div class="view-dialog local-notfind">' +
				'<div class="v-cont">' +
					'<div class="v-header">' +
						'<img src="../images/local.notfind.png" width="65px" />' +
					'</div>' +
					'<div class="v-body">' +
						'未能定位到您所在的城市，为了计算结果' +
						'更加精准，请选择您所在的城市。' +
					'</div>' +
					'<div class="v-footer">' +
						'<button type="button" class="mui-btn" v-tap="{fn: closeHandler, name: 1}">选择城市</button>' +
					'</div>' +
					'<span class="iconfont icon-close" v-tap="{fn: closeHandler}"></span>' +
				'</div>' +
			'</div>' 
	  ,
	  mounted: function(){
	  	var This = this;
	  	app.plusReady(function(){
	  		this.key.addEventListener('backbutton', function() {
		        This.closeHandler();
		    }, false);
	  	})
	  },
	  methods: {
	    
	    closeHandler: function(val) {
	    	val = isNaN(val && val.name);
	    	this.$emit('close', !val);
	    }
	  },
	})	
}());

