/**
 * 分享弹出层
 * date 2018-1-19
 */
;(function(){
	
	Vue.component('share', {
	  template: 
	  	'<section class="view-share"  v-move="closeHandler" v-tap="closeHandler">' +
			'<div class="share-list">' +
				'<ul class="b-border">' +
					'<li v-tap="{fn: shareAction, name: \'weixin\'}">' +
						'<i class="mui-icon iconfont icon-c-wchat"></i><span>微信</span>' +
					'</li>' +
					'<li v-tap="{fn: shareAction, name: \'weixinCircle\'}">' +
						'<i class="mui-icon iconfont icon-c-friend"></i><span>朋友圈</span>' +
					'</li>' +
					'<li v-tap="{fn: shareAction, name: \'qq\'}">' +
						'<i class="mui-icon iconfont icon-qq"></i><span>QQ好友</span>' +
					'</li>' +
				'</ul>' +
				'<button class="mui-btn" v-tap="closeHandler">取消</button>' +	
			'</div>' +
		'</section>',
	  methods: {
	    closeHandler: function() {
	    	this.$emit('close');
	    },
	    shareAction: function(e){
	    	var shareId = e.name;
	    	this.closeHandler();
	    	share.goShare(shareId, 
	    		{
	    			title: "工资计算器",
					content: "精准无误的计算您的工资，查看社保，医疗，公积金等缴纳详情"
				}
			);
	    }
	  }
	})	
}());

