(function($,bws) {
	$.init({swipeBack:true});
	
	
	var me=null,ws=null;
	bws.ws = ws;
	bws.me = me;
	
	var closeBtn = g('close');
	var title = g('title');
	
	g('close').addEventListener('tap',function(){
		plus.webview.currentWebview().close();
	},false);
	
	$.plusReady(function(){
		me = plus.webview.currentWebview();
		var scalable = me.scalable===true ? true:false,
			url = decodeURIComponent(me.url);
		ws = plus.webview.create(url,'open_web',{
			top:app.headerH+'px',
			bottom:"0px",
			errorPage:'404.html',
			scalable:scalable
		});
		
		//'.*\\.(jpg|png|jpeg|bmp|apk)\\b'
		ws.overrideUrlLoading({
			match:'.*\\.(ipa|apk|zip|rar|exe|7z|sh|gz)\\b'
		},function(e){
			console.log(e.url);
		});
		
		if(me.cssText) {
			ws.setCssText(me.cssText);
		}
		if(me.jsFiles) {
			if(!$.isArray(me.jsFiles)){
				me.jsFiles = [me.jsFiles];
			}
			$.each(me.jsFiles, function(i,js) {
				ws.appendJsFile(js);
			});
		}
		if(me.showCloseBtn){
			g('close').classList.remove('mui-hidden');
		}
		if(me.titleBackground){
			g('navBar').style.background=me.titleBackground;
		}
		if(me.enableHistory){
			mui.oldBack = mui.back;
			mui.back = function() {
				plus.webview.currentWebview().close();
//				var backScrpt = ['(function(){',
//					'var currVw=plus.webview.currentWebview();',
//					'currVw.back();',
//					'setTimeout(function(){',
//						'if(currVw) currVw.parent().close();',
//					'},310);})()'].join('');
//				ws.evalJS(backScrpt);
			};
		}
		if(!me.title || me.autoTitle){
			ws.addEventListener("titleUpdate", function(e){
				g('title').innerText = e.title;
			}, false);
		}else if(me.title){
			g('title').innerText = decodeURIComponent(me.title);
		}
		
		ws.addEventListener('progressChanged',function(e){
			$("#progress").progressbar().setProgress(e.progress);
			if(e.progress===100){
				$("#progress").progressbar().hide();
				$("#progress")[0].classList.add('mui-hidden');
			}
		},false);
		ws.addEventListener('loading',function(e){
			$("#progress")[0].classList.remove('mui-hidden');
			$("#progress").progressbar({progress:1}).show();
		},false);
		ws.addEventListener("loaded", function(e){
			if(!ws.parent()) me.append(ws);
			$("#progress").progressbar().setProgress(100);
		}, false);
		if(me.showTiming==='titleUpdate'){
			ws.addEventListener("titleUpdate", function(e){
				if(!ws.parent()) me.append(ws);
			}, false);
		}else if(me.showTiming==='firstTime'){
			me.append(ws);
		}
	});
})(mui, window.bws={});