(function($,myStorage,jscope,shebaoSvc,doc) {
	var obj = {};
	obj.state = {};
	obj.secInfo = {};
	obj.securityAcctId = null;
	obj.refresh = 0;
	obj.monthDetails = {};
	obj.costDetails = {};
	var explanIds={med:0,Pen:0};
	app.listenerBack([{
		view: 'security-calc',
		eventName: 'refresh_data',
		data: {}
	}])
	$('.mui-scroll-wrapper').scroll({ bounce: false });
	HTMLCollection.prototype.indexOf =  Array.prototype.indexOf;
	

	var info = doc.getElementById('info');
	var infoSubBox = doc.getElementById('infoSub');
	var swipeSubBtn = doc.getElementById('swipeSub');
	var slider = doc.getElementById('slider');
	var sliderBar = doc.getElementById('sliderBar');
	var scrollBox = doc.querySelector('.mui-scroll');
	var sliderProgressBar = doc.getElementById('sliderProgressBar');
	var sliderProgressBarX = doc.getElementById('sliderProgressBarX');
	var sliderSegmentedControl = doc.getElementById('sliderSegmentedControl');
	var sliderSegmentedControlX = doc.getElementById('sliderSegmentedControlX');
	
	var refreshBtn =  doc.getElementById('refresh');
	var ybMoney =  doc.getElementById('ybMoney');
	var ylMoney =  doc.getElementById('ylMoney');
    var imgCode = doc.getElementById('imgCode');
    var safeCodeBox = doc.getElementById('safeCode');
	var sRefreshBtn = doc.getElementById('sRefresh');
	var payStateMark = doc.getElementById('payState');

	var kefuBtn = doc.getElementById('kefu');
	var weixinServicesBtn = doc.getElementById('weixinServices');
	var QQServicesBtn = doc.getElementById('QQServices');
	
	var showAniText = function(elId,text,callback){		
		var wh = document.body.clientHeight;
		var ww = document.body.clientWidth;
		var txt =document.createElement('div');
		txt.id = 'ani_'+elId;
		txt.className=text>0?"ani-txt up":"ani-txt down";
		txt.style.fontSize = '60px';
	    txt.style.top = (wh/2-20)+"px";
	    txt.style.left = (ww/2-92)+"px";
	    document.body.appendChild(txt);
		 
	    var el = document.getElementById(elId);
	    txt.innerHTML= text>0?'+'+text.toFixed(2):text.toFixed(2);
	    txt.classList.add('ani-n');
	    txt.style.left = el.offsetLeft+"px";
	    txt.style.top = el.offsetTop+"px";
	    txt.style.fontSize = '24px';
	    txt.style.opacity = 0;
 		setTimeout(function(){
 			document.body.removeChild(txt);
 		},1600);
		callback();
	};
	var showFlash = function(data){
		var ybMoneyO =  parseFloat(isNaN(obj.secInfo.medicalAccountBalance)?"0":obj.secInfo.medicalAccountBalance),
			ylMoneyO =  parseFloat(isNaN(obj.secInfo.pensionAccountBalance)?"0":obj.secInfo.pensionAccountBalance);
		if(!isNaN(data.medicalAccountBalance)&&data.medicalAccountBalance!==""){
			var ybMoneyN =  parseFloat(data.medicalAccountBalance);
			if(ybMoneyO===0){
				new CountUp("ybMoney", 0, ybMoneyN, 2, 2.5).start();
			}else if(ybMoneyN!==ybMoneyO){
				showAniText("ybMoney",ybMoneyN-ybMoneyO,function(){
					new CountUp("ybMoney", ybMoneyO, ybMoneyN, 2, 2.5).start();
				});
			}
		}else{
			g('ybMoney').innerText=data.medicalAccountBalance||"-";
		}
		if(!isNaN(data.pensionAccountBalance)&&data.pensionAccountBalance!==""){
			var ylMoneyN =  parseFloat(data.pensionAccountBalance);
			if(ylMoneyO===0){
				new CountUp("ylMoney", 0, ylMoneyN, 2, 2.5).start();
			}else if(ylMoneyN!==ylMoneyO){
				setTimeout(function(){
					showAniText("ybMoney",ylMoneyN-ylMoneyO,function(){
						new CountUp("ylMoney", ylMoneyO, ylMoneyN, 2, 2.5).start();
					});
				},1500);
			}
		}else{
			g('ylMoney').innerText=data.pensionAccountBalance||"-";
		}
	};
	var rewriteData = function(data) {
        var perAmt = 0;
        var comAmt = 0;
        var list = data.joySecurityAccountPayments.concat();
		$.each(list,function (i,ins) {
			perAmt += parseFloat(ins.payPersonal===null?0:ins.payPersonal);
			comAmt += parseFloat(ins.payCompany===null?0:ins.payCompany);
			ins.amt = parseFloat(ins.payPersonal===null?0:ins.payPersonal) + parseFloat(ins.payCompany===null?0:ins.payCompany);
			ins.payPersonal = ins.payPersonal===null?'-':ins.payPersonal;
			ins.payCompany =  ins.payCompany===null?'-':ins.payCompany;
		});
        return {perAmt:perAmt,comAmt:comAmt,payMonth:data.payMonth,list:list};
	};
	var getPieOption = function (datas,nameLabel,valueLabel){
	 	var kind = [];
	 	var data = [];
	 	var chartData = datas.newSecurityPaymentList.slice(0,datas.newSecurityPaymentList.length-1);
		$.each(chartData,function (i,ins) {
			kind.push(ins[nameLabel]);
			data.push({value:ins[valueLabel],name:ins[nameLabel]});
		});
	 	return {
		    title : {
		    	text: datas.payMonth + " 缴费明细",
		    	right:0,
		    	top:10,
		    	textStyle:{
		    		color:'#e51c23',
		    		fontSize:16,
		    		fontWeight:'normal'
	    		}
		    },
		    legend:{
		    	orient:'vertical',
		    	align:'right',
		    	bottom:20,
		    	right:0,
		    	data:kind
		    },
		    series : [{
		        name: '险种',
		        type: 'pie',
		        startAngle:-15,
		        radius : [0,'80%'],
		        center: ['30%', '50%'],
		        data:data,
		        color:['#00a8df','#00a394','#fe2b36','#ffb226','#00638b','#16C7C7'],
		        itemStyle: {
		            emphasis: {
		                shadowBlur: 10,
		                shadowOffsetX: 0,
		                shadowColor: 'rgba(0, 0, 0, 0.5)'
	                }
		        }
	       }]
		};
	 };
	var setRecentPie = function (data){
		if(data){
			var chart = echarts.init(doc.getElementById('pieChart'))
			var option = getPieOption(data,'insuranceName','insuranceTotalAmt');
			chart.setOption(option);		
		
		}else{
			g("dataBox").style.display = "none";
			g("functionBox1").style.marginTop ="0px";
		}
		
	};

	var getSecInfo = function (secId,update) {
		if(!app.checkLogin()) return;
		var secInfo = myStorage.getItem('SecInfo_'+secId);
		if(!secInfo||secInfo.medicalPayType===undefined) update=true;
		shebaoSvc.getSecInfo(secId,update).then(function (data) {
			g('header').innerText=data.name;
			g('payState').classList[data.securityState=='正常'?'remove':'add']('bg-red');
			g('sbar3').innerText=data.medicalPayType?'医疗支出':'工具';
			g('fsbar3').innerText=data.medicalPayType?'医疗支出':'工具';
			g('costList').classList[!data.medicalPayType?'add':'remove']('mui-hidden');
			g('toolList').classList[data.medicalPayType?'add':'remove']('mui-hidden');
			jscope.bind(info,data,'info');
			if(obj.securityAcctId==obj.secInfo.securityAcctId){
				showFlash(data);
			}else{
				g('ybMoney').innerText=data.medicalAccountBalance||"-";
				g('ylMoney').innerText=data.pensionAccountBalance||"-";
			}
			obj.secInfo = data;
			if(obj.refresh){
				refresh();
			}
			if($('#slider').slider().slideNumber===2 && obj.secInfo.medicalPayType && g('costList').getAttribute('secid')!=obj.securityAcctId){
				getMedicalPayList(obj.securityAcctId);
			}
			getNounsExplanation(data.payCity);
			getFuncExplanation(data.payCity);	
		}).catch(function(err){
			console.error(err.message,err);
			if(err.code>9999){
				$.toast(err.message);
			} 
		});
	};
	
	var getSecNewList = function (secId,update) {
		if(!app.checkLogin()) return;
		shebaoSvc.getNewSecPayList(secId,update).then(function(data){
			if(data && !$.isEmptyObject(data)){
				g('dataBox').classList.remove('mui-hidden');
				setRecentPie(data);
				var lastTable = doc.getElementById('lastTable');
				jscope.bind(lastTable,{dtable:data.newSecurityPaymentList});
				var rows = lastTable.children;
				var colors = ['','#00a8df','#00a394','#fe2b36','#ffb226','#00638b','#16C7C7','#cdcbc5'];
				for(var i=1; i<rows.length;i++){
					rows[i].children[0].style.backgroundColor=colors[i];
					rows[i].children[0].style.borderColor=colors[i];
					rows[i].children[0].style.color='#fff';
				}
			}else{
				g('dataBox').classList.add('mui-hidden');
			}
		}).catch(function(err){
			console.error(err.message,err);
			if(err.code>9999) $.toast(err.message);
		});
	};
	var getSecDetails = function (secId, update) {
		if(!app.checkLogin()) return;
		shebaoSvc.getSecAcctDetails(secId, update).then(function (data) {
			var secList = doc.getElementById('secList');
			jscope.bindRepeat(secList,{secList:data});
			setTimeout(function(){
				createDetails(data);
			},100);
			g('refresh').children[0].classList.remove('spin');
		}).catch(function(err){
			console.error(err.message,err);
			g('refresh').children[0].classList.remove('spin');
			$.toast(err.message);
		});
	};
	var getMonthDetail = function(secId,month,show){
		shebaoSvc.getSecPayListByMonth(secId,month).then(function (data) {
			if($.isEmptyObject(data)) data = {
				payMonth:month,
				newSecurityPaymentList:[],
				joySecurityAccountPayments:[]
			};
			obj.monthDetails[data.payMonth] = data.newSecurityPaymentList;
			createMonthDetail(data.payMonth,data.newSecurityPaymentList);
			if(show) showDetail(data.payMonth);
			plus.nativeUI.closeWaiting();
		}).catch(function(err){
			console.error(err.message,err);
			plus.nativeUI.closeWaiting();
		});
	};
	var getMedicalPayList = function(secId, update){
		plus.nativeUI.showWaiting();
		shebaoSvc.getMedicalPay(secId, update).then(function(data){
			createCostList(data,secId);
			if(data.medicalPayType==2) createCostDetails(data);
			plus.nativeUI.closeWaiting();
		}).catch(function(err){
			console.error(err.message,err);
			plus.nativeUI.closeWaiting();
		});
	};
	
	var LoadData = function (secId) {
		g('refresh').children[0].classList.add('spin');
    	getSecInfo(secId);
		getSecNewList(secId);
		setTimeout(function(){getSecDetails(secId);},10); 
	};
	
	var settime = function () {
		var intSms = null;
		var sec = 120;
		intSms = setInterval(function() {
			sec--;
			if (sec <= 0) {
				clearInterval(intSms);
				btnGetMsg.innerHTML = '获取验证码';
				btnGetMsg.removeAttribute('disabled');
			} else {
				btnGetMsg.innerHTML = sec + 's';
				btnGetMsg.setAttribute('disabled','disabled');
			}
		}, 1000);
	};
	var getMsgCode = function() {
		var datasObj = {
			accountId:obj.secInfo.id,
			cityCode: obj.secInfo.payCity,
			grabType: '0',//0-社保,1-公积金
			telCodeType: '2'
		};
		if(!g('safeCodeRow').classList.contains('mui-hidden')){
			var safeCode = g('safeCode').value;
			if(!safeCode || !safeCode.trim()){
				safeCodeBox.focus();
				return $.toast('请先输入图形验证码');
			}
			datasObj.safeCode = safeCode;
		}
		btnGetMsg.innerHTML = '<i class="mui-spinner"></i>';
		btnGetMsg.setAttribute('disabled','disabled');
		shebaoSvc.getTelcode(datasObj).then(function(data) {
			settime();
		}).catch(function(err) {
			console.error(err.message,err);
			$.alert(err.message);
			btnGetMsg.innerHTML = '获取验证码';
			btnGetMsg.removeAttribute('disabled');
			if(!g('safeCodeRow').classList.contains('mui-hidden')){
				getSafeCode();
			}
		});
	};
	
    var getSafeCode = function (callback) {
        callback = callback || $.noop;
    	imgCode.setAttribute('src','../images/yzm.gif');
        shebaoSvc.getSafeCode(obj.secInfo.payCity).then(function (data) {
        	var hasInput = false;
        	if(data.saveCodePath){
        		hasInput = true;
        		g('safeCodeRow').classList.remove('mui-hidden');
        		imgCode.setAttribute('src',data.saveCodePath);
        		safeCodeBox.value = '';
            	safeCodeBox.focus();
        	}else{
        		g('safeCodeRow').classList.add('mui-hidden');
        	}
            if(data.phoneCode=='1'){
            	hasInput = true;
            	g('phoneCode').value = '';
        		g('phoneCodeRow').classList.remove('mui-hidden');
        	}else{
        		g('phoneCodeRow').classList.add('mui-hidden');
        	}
            callback(hasInput);
        }).catch(function (err) {
        	console.error(err.message,err);
            $.toast('连接社保网失败');
        });
    };
    var refresh = function () {
    	obj.refresh=0;
        getSafeCode(function (hasInput) {
        	if(hasInput){
        		$('#yzm').popover('show');
        	}else{
        		refreshSec();
        	}
        });
    };
    var refreshSec = function () {
    	document.activeElement.blur();
    	var safeCode = g('safeCode').value.trim();
    	var phoneCode = g('phoneCode').value.trim();
    	if(!g('safeCodeRow').classList.contains('mui-hidden') && safeCode.length==0){
    		g('safeCode').focus();
	    	return $.toast("请输入图形验证码");
    	}
    	if(!g('phoneCodeRow').classList.contains('mui-hidden') && phoneCode.length==0){
    		g('phoneCode').focus();
	    	return $.toast("请输入短信验证码");
    	}
    	
        $('#yzm').popover('hide');
        progessBar.startProgess();
        shebaoSvc.refreshSecurity(safeCode,obj.securityAcctId,phoneCode).then(function (data) {
        	progessBar.stopProgess(function(){
        		var list = g('secList'),
        			el = list.children[0].cloneNode(true);
	            list.innerHTML = '';
	            list.appendChild(el);
	            
	            g('refresh').children[0].classList.add('spin');
	            
	            getSecInfo(obj.securityAcctId,true);
	            getSecNewList(obj.securityAcctId, true);
	            getSecDetails(obj.securityAcctId, true);
	            getMedicalPayList(obj.securityAcctId, true);
        	});
        }).catch(function (err) {
        	g('refresh').children[0].classList.remove('spin');
        	progessBar.hideProgess();
        	if(err.code=="90012"){
        		$.confirm("绑定的社保账户密码错误，如果您已修改密码请重新绑定账户。现在重新绑定账户？",
    				"刷新社保数据",['是','否'],function(event){
    				if ( 0===event.index ) {
						app.showSheBaoAdd();
	                }
    			});
        	}else if(err.code=="90008"){
        		$.alert(err.message);
        	}else if(err.message==='abort'){
        		$.alert('请求异常终止，请返回并重新进入查看');
        	}else{
				$.toast(err.message);	
			}
        });
    };
 	
	var scrollFunc = function(){
		var isup = swipeSubBtn.classList.contains('fa-angle-double-up');
		var st = isup ? -243 : -107;
		if(scroll.y<=st){
			sliderSegmentedControlX.innerHTML = sliderSegmentedControl.innerHTML;
			sliderProgressBarX.setAttribute("style",sliderProgressBar.getAttribute('style'));
			sliderBar.style.display = 'block';
		}else{
			sliderBar.style.display = 'none';
		}
	};
	var swipeUp = function(){
		var isup = swipeSubBtn.classList.contains('fa-angle-double-up');
		if(isup){
			swipeSubBtn.classList.remove('fa-angle-double-up');
			swipeSubBtn.classList.add('fa-angle-double-down');
			infoSubBox.style.height='4px';
			infoSubBox.style.padding='0 10px';
			payStateMark.style.display = 'none';
		}else{
			swipeSubBtn.classList.remove('fa-angle-double-down');
			swipeSubBtn.classList.add('fa-angle-double-up');
			infoSubBox.style.height='140px';
			infoSubBox.style.padding='5px 10px';
			payStateMark.style.display = '';
		}
	};
    var slideFunc = function(event) {
		var isup = swipeSubBtn.classList.contains('fa-angle-double-up');
		var st = isup ? -243 : -107;
		if(scroll.y<st) scroll.scrollTo(0,st,0);
		sliderProgressBarX.setAttribute("style",sliderProgressBar.getAttribute('style'));
		var xactive = doc.querySelector('#sliderBar .mui-control-item.mui-active');
		xactive.classList.remove('mui-active');

		var index = event.detail.slideNumber;
		var xitems = doc.querySelectorAll('#sliderBar .mui-control-item');
		xitems[index].classList.add('mui-active');
	
		if(index===2 && obj.secInfo.medicalPayType && g('costList').getAttribute('secid')!=obj.securityAcctId){
			getMedicalPayList(obj.securityAcctId);
		}
	};
  
    
    var oldBack = $.back;
    var closeDetail = function(){
    	document.getElementById('monthBox').classList.remove('mui-active');
    	document.getElementById('costBox').classList.remove('mui-active');
		obj.mask&&obj.mask.close();
		$.back = oldBack;
    };
    var createDetails = function(data){
    	if(data.length===0) return;
    	var item,mitem,yms,fullMonth;
    	g('monthGroup').innerHTML='';
    	for(var i=data.length-1;i>=0;i--){
    		yms = data[i].securityInfoList;
    		for(var x=yms.length-1;x>=0;x--){
    			im = yms[x];
    			fullMonth = im.year+''+(im.month>9?im.month:'0'+im.month);
    			mitem = document.createElement('div');
				mitem.className='mui-slider-item'+(g('monthGroup').childElementCount===0?' mui-active':'');
				mitem.setAttribute('month',fullMonth);
				mitem.innerHTML=[
					'<div class="month-detail mui-popup mui-popover">',
						'<div class="mui-popup-title">',fullMonth,' 缴费明细</div>',
						'<div class="mui-popup-inner"></div>',
						'<i class="mui-icon mui-icon-closeempty"></i>',
					'</div>'].join('');
				g('monthGroup').appendChild(mitem);
    		}
    	}
    	g("monthBox").style.visibility='hidden';
    	g("monthBox").classList.add('mui-active');
		$("#monthBox").slider().refresh();
		g("monthBox").classList.remove('mui-active');
		g("monthBox").style.visibility='visible';
    	
    };
    var createMonthDetail = function(fullMonth,detail){
    	var item,
    		mitem=g('monthGroup').querySelector('.mui-slider-item[month="'+fullMonth+'"]')
    		mcon=mitem.querySelector('.mui-popup-inner');
		mitem.setAttribute('create','1');
		if(mcon.children.length>0) return;
		if(detail.length>0){
			$.each(detail,function(index,mi){
				item = document.createElement('div');
				if(index==detail.length-1){
					item.className='ins mui-clearfix total';
					item.innerHTML=[
						'<label>'+mi.insuranceName+':</label>',
						'<div class="ins-info">',
							mi.insuranceTotalAmt,' 元',
						'</div>'].join('');
				}else{
					item.className='ins mui-clearfix';
					item.innerHTML=[
						'<label>'+mi.insuranceName+'</label>',
						'<div class="ins-info">',
							'<div><span>单位</span>',mi.payCompany==='-'?'-':mi.payCompany+' 元','</div>',
							'<div><span>个人</span>',mi.payPersonal==='-'?'-':mi.payPersonal+' 元','</div>',
						'</div>'].join('');
				}
				mcon.appendChild(item);
			});
		}else{
			mcon.innerHTML='<p class="ins-empty">未查到本月缴费数据！</p>';
		}
    };
    var showDetail = function(fullMonth){
		var detail = obj.monthDetails[fullMonth];
		if(!detail){
			plus.nativeUI.showWaiting();
			getMonthDetail(obj.securityAcctId,fullMonth,true);
		}else{
			var monthBox=g('monthBox'),
			 	monthGroup = g('monthGroup'),
				active = monthGroup.querySelector('.mui-slider-item[month="'+fullMonth+'"]'),
				idx = monthGroup.children.indexOf(active),
				sleft = idx*(0-document.body.clientWidth),
				slider = $('#monthBox').slider(),
				st = slider.options.scrollTime,
				se = slider.options.scrollEasing;
			obj.monthDetails.currMonth = fullMonth;	
			//jel('#monthGroup .mui-slider-item.mui-active').removeClass('mui-active');	
			if(!monthBox.classList.contains('mui-active')){
				var mask = obj.mask;
				if(!mask){
					mask = obj.mask = $.createMask();
					mask[0].addEventListener('tap',function(){
						closeDetail();
					},false);
				}
				$.back = closeDetail;
				mask.show();
				monthBox.classList.add('mui-active');
				slider.gotoItem(idx,0);
			}else{
				slider.gotoItem(idx,st);
			}
		}
	};
	var goDetail = function(num){
		console.log('currMonth:'+obj.monthDetails.currMonth);
		var activeEl = g('monthGroup').querySelector('.mui-slider-item.mui-active');
		if(!activeEl) return;
		activeEl = num>0?activeEl.nextElementSibling:activeEl.previousElementSibling;
		if(!activeEl) return;
		showDetail(activeEl.getAttribute('month'));
	};
	var goMonthItem = function(fullMonth){
		var active = g('monthGroup').querySelector('.mui-slider-item[month="'+fullMonth+'"]'),
			nextEl = active.nextElementSibling,
			prevEl = active.previousElementSibling,
			nextMonth = nextEl?nextEl.getAttribute('month'):false,
			prevMonth = prevEl?prevEl.getAttribute('month'):false;		
		g('btnNextM').style.display=nextEl?'block':'none';
		g('btnPrevM').style.display=prevEl?'block':'none';		
		if(nextMonth && !obj.monthDetails[nextMonth]) {
			getMonthDetail(obj.securityAcctId,nextMonth);
		}
		if(prevMonth && !obj.monthDetails[prevMonth]){
			getMonthDetail(obj.securityAcctId,prevMonth);
		}
	};
	
	var createCostDetails=function(data){
		var dateStr1,costi,pay,md,feeList,feei,
			payType = ['普通支出','门诊','住院','购药','挂号','特殊支出'];
		g('costGroup').innerHTML='';
		for(var x=data.payList.length-1;x>=0;x--){
			pay = data.payList[x];
			for(var y=0;y<pay.monthDate.length;y++){
				md = pay.monthDate[y];
				dateStr1 = md.payDateTime.substr(0,4)+'-'+md.payDateTime.substr(4,2)+'-'+md.payDateTime.substr(6,2),
				costi = document.createElement('div');
				costi.className='mui-slider-item';
				costi.setAttribute('date',md.payDateTime);
				costi.setAttribute('idx',x+'_'+y);
				feeList = '';
				for(var fi in md.feeList){
					feei = md.feeList[fi].split(':');
					feeList +=[
						'<div class="mui-clearfix">',
							'<div>',
								'<b>',feei[0],'</b>',
								'<span><em>',feei[1],'</em>元</span>',
							'</div>',
						'</div>'].join('');
				}
				costi.innerHTML=[
					'<div class="cost-detail mui-popup mui-popover">',
						'<div class="mui-popup-title">',md.hospName,'</div>',
						'<div class="mui-popup-inner',md.feeTypeValue==0?' fee-x':' fee-t','">',
							'<div class="chead mui-clearfix">',
								'<span class="mui-pull-left">',dateStr1,'</span>',
								'<span class="mui-pull-right">类型：',payType[md.payTypeValue],'</span>',
							'</div>',
							feeList,
							'<div class="cfoot mui-clearfix">',
								'<label class="mui-pull-left">总费用：</label>',
								'<span class="mui-pull-right amt">',md.payTotal,'元</span>',
							'</div>',
						'</div>',
						'<i class="mui-icon mui-icon-closeempty"></i>',
					'</div>'].join('');
				g('costGroup').appendChild(costi);
			}
		}
		g("costBox").style.visibility='hidden';
    	g("costBox").classList.add('mui-active');
		g("costBox").classList.remove('mui-active');
		g("costBox").style.visibility='visible';
	 
	};
	var createCostList = function(data){
		var costList = g('costList'),
			type=data.medicalPayType,
			payType = ['普通支出','门诊','住院','购药','挂号','特殊支出'],
			pay,md,dateStr,liYear,liCost,innerList,liItem,stotal;
		if(type===0){
			costList.innerHTML='<div class="empty">该城市暂不支持</div>';
		}else if(!data.payList||data.payList.length===0){
			costList.innerHTML='<div class="empty">没有任何医疗支出项目</div>';
		}else{
			costList.innerHTML='';
			costList.setAttribute('secid',obj.securityAcctId);
			for(var x=0;x<data.payList.length;x++){
				pay= data.payList[x];
				liYear = document.createElement('li');
				liYear.className = 'mui-table-view-cell mui-collapse cost';
				liYear.innerHTML=[
					'<a class="mui-navigate-right" href="#">',
						'<span>',pay.year,'</span>',
					'</a>'
				].join('');
				costList.appendChild(liYear);
				if(type===1){
					innerList = document.createElement('ul');
					innerList.className = 'mui-table-view mui-card payy';
					innerList.innerHTML=[
						'<li class="mui-table-view-cell">',
							'<label>门诊</label>',
							'<p><b>消费</b><span><em>',pay.monthDate.clinicPay,'</em>元</span></p>',
							'<p><b>报销</b><span><em>',pay.monthDate.clinicPayLarge,'</em>元</span></p>',
							'<p><b>自费</b><span><em>',pay.monthDate.clinicPayInside,'</em>元</span></p>',
						'</li>',
						'<li class="mui-table-view-cell">',
							'<label>住院</label>',
							'<p><b>消费</b><span><em>',pay.monthDate.hospPayPlan,'</em>元</span></p>',
							'<p><b>报销</b><span><em>',pay.monthDate.hospPayLarge,'</em>元</span></p>',
							'<p><b>自费</b><span><em>',pay.monthDate.hospPayInside,'</em>元</span></p>',
						'</li>'
					].join('');
					liYear.appendChild(innerList);
				}else if(type===2){
					innerList = document.createElement('ul');
					innerList.className = 'mui-table-view payi';
					liYear.appendChild(innerList);
					for(var y=pay.monthDate.length-1;y>=0;y--) {
						md = pay.monthDate[y];
						liItem = document.createElement('li');
						liItem.className='mui-table-view-cell';
						liItem.setAttribute('type',md.payTypeValue);
						liItem.setAttribute('date',md.payDateTime);
						liItem.setAttribute('idx',x+'_'+y);
						dateStr = md.payDateTime.substr(4,2)+'-'+md.payDateTime.substr(6,2);
						liItem.innerHTML = [
							'<span class="mui-pull-left pay-date">',dateStr,'</span>',
							'<span class="pay-de-amount"><em class="',md.feeTypeValue=='0'?'color-green':'color-red','">',
								md.payAccount,
							'</em>元</span>',
							'<span class="pay-type">',
								'<i class="',md.feeTypeValue=='0'?' fa fa-long-arrow-down':' fa fa-long-arrow-up','"></i>',
								payType[md.payTypeValue],
							'</span>',
							'<p class="mui-ellipsis">',
								'<span class="pay-toal-amount">总费用:<em>'+md.payTotal+'</em>元</span>',
							'</p>',
							'<p class="pay-hosname">',
								md.hospName,
							'</p>'
						].join('');
						innerList.appendChild(liItem);
					}
				}
			}
		}
	};
	var showCostDetail = function(dataStr){
		
		obj.costDetails.currDate = dataStr;
		jel('#costGroup .mui-slider-item.mui-active').removeClass('mui-active');
		var costGroup = g('costGroup'),costBox=g('costBox'),
			active = costGroup.querySelector('.mui-slider-item[idx="'+dataStr+'"]'),
			idx = costGroup.children.indexOf(active),
			sleft = idx*(0-document.body.clientWidth),
			slider = $('#costBox').slider(),
			st = slider.options.scrollTime,
			se = slider.options.scrollEasing;
		g('btnNextMM').style.display=active.nextElementSibling?'block':'none';
		g('btnPrevMM').style.display=active.previousElementSibling?'block':'none';
		if(!costBox.classList.contains('mui-active')){
			var mask = obj.mask;
			if(!mask){
				mask = obj.mask = $.createMask();
				mask[0].addEventListener('tap',closeDetail,false);
			}
			costBox.classList.add('mui-active');
			mask.show();
			$.back = closeDetail;
			slider.gotoItem(idx,0);
		}else{
			slider.gotoItem(idx,st);
		}
		active.classList.add('mui-active');
	};
	var goCostDetail = function(num){
		console.log('currCost:'+obj.costDetails.currDate);
		var activeEl = g('costGroup').querySelector('.mui-slider-item.mui-active');
		if(!activeEl) return;
		activeEl = num>0?activeEl.nextElementSibling:activeEl.previousElementSibling;
		if(!activeEl) return;
		showCostDetail(activeEl.getAttribute('idx'));
	};
	
	var getNounsExplanation = function(payCity,callback){
		callback = callback || $.noop;
		shebaoSvc.getNounsExplanation(payCity).then(function(data){
			if(data.med){
				explanIds.med = data.med;
				g('ybTip').classList.remove('mui-hidden');
				callback();
			}else{
				explanIds.med = 0;
				g('ybTip').classList.add('mui-hidden');
			}
			if(data.Pen){
				explanIds.Pen = data.Pen;
				g('ylTip').classList.remove('mui-hidden');
				callback();
			}else{
				explanIds.Pen = 0;
				g('ylTip').classList.add('mui-hidden');
			}
		}).catch(function(err){
			console.error(err.message,err);
			$.toast(err.message);
		});
	};
	var getFuncExplanation = function(payCity){
		shebaoSvc.getFuncExplanation(payCity).then(function(data){
			if(data[1]){
				g('functionBoxFirst').classList.remove('mui-hidden');
				g('functionBox1').innerHTML = data[1];
			}else{
				g('functionBoxFirst').classList.add('mui-hidden');
			}
			if(data[2]){
				g('functionBoxSecond').classList.remove('mui-hidden');
				g('functionBox2').innerHTML = data[2];
			}else{
				g('functionBoxSecond').classList.add('mui-hidden');
			}
			if(data[3] && obj.secInfo.medicalPayType){
				g('functionBoxThird').classList.remove('mui-hidden');
				g('functionBox3').innerHTML = data[3];
			}else{
				g('functionBoxThird').classList.add('mui-hidden');
			}
		});
	};
	
	var showTip = function(boxId,cid,aid){
		var tid = g(cid).getAttribute('aid');
		if(tid!==aid.toString()){
			newsSvc.documentContent(aid).then(function(data){
				g(cid).innerHTML = data.content;
				g(cid).setAttribute("aid",aid);
				$('#'+boxId).popover('show');
			}).catch(function(err){
				$.toast(err.message);
			});
		}else{
			$('#'+boxId).popover('show');
		}
		plus.nativeUI.closeWaiting();
	};
	
	$("#secList").on("tap",'li.mui-collapse',function(){
		var li = this;
		var sc = $('#tScroll').scroll();
		setTimeout(function(){
			var tScroll = document.getElementById('tScroll');
			if(tScroll.children[0].offsetHeight>tScroll.offsetHeight){
				var slider = document.getElementById('slider');
				if(li.classList.contains('mui-active')){
					var ele=li,i=-1;
					while(ele = ele.previousElementSibling) i++; 
					sc.scrollTo(0,-(slider.offsetTop+(i*43)),0);
				}else{
					sc.scrollTo(0,0-slider.offsetTop,0);
				}
			}else{
				sc.scrollTo(0,0,0);
			}
		},100);
	});
	$("#secList").on("tap",'li.mui-collapse>.mui-table-view>li',function(){
		var year = parseInt(this.parentNode.getAttribute('year')),
			month = parseInt(this.getAttribute('month'));
		var fullMonth = year+''+(month>9?month:'0'+month);
		showDetail(fullMonth);
		return false;
	});
	$("#costList").on("tap",'.payi li',function(){
		var dataStr = this.getAttribute('idx');
		showCostDetail(dataStr);
		return false;
	});
	
	g("btnPrevM").addEventListener("tap",function(){
		goDetail(-1);
	},false);
	g("btnNextM").addEventListener("tap",function(){
		goDetail(1);
	},false);
	g("btnPrevMM").addEventListener("tap",function(){
		goCostDetail(-1);
	},false);
	g("btnNextMM").addEventListener("tap",function(){
		goCostDetail(1);
	},false);

	g('monthBox').addEventListener('slide', function(event) {
		var mitem = g('monthGroup').children[event.detail.slideNumber];
		goMonthItem(mitem.getAttribute('month'));
	},false);
	$("#monthBox").on('tap','.month-detail .mui-icon-closeempty',function(){
		closeDetail();
		return false;
	});
	$("#monthBox").on('tap','.btnZx',function(){
		$.openWindow({
			url:"_www/view/advice-cate.html",
			id:'advice-cate.html',
			show:{aniShow:'slide-in-right'},
			waiting:{autoShow:false}
		});
		return false;
	});
	
	g('costBox').addEventListener('slide', function(event) {
		var mitem = g('costGroup').children[event.detail.slideNumber];
		showCostDetail(mitem.getAttribute('idx'));
	},false);
	$("#costBox").on('tap','.cost-detail .mui-icon-closeempty',function(){
		closeDetail();
		return false;
	});
	$("body").on('touchend','.mui-backdrop-action',function(){
		document.activeElement.blur();
	});
	$("body").on('tap','.change button',function(){
		mui.openWindow({url: 'security.bind.html', id: 'security.bind'});
	});

	refreshBtn.addEventListener('tap',refresh,false);
	swipeSubBtn.addEventListener('tap',swipeUp,false);
	slider.addEventListener('slide', slideFunc,false);
    imgCode.addEventListener('touchend',function(e){
    	getSafeCode(function(){
    		safeCodeBox.value = '';
            safeCodeBox.focus();
    	});
    	e.preventDefault();
    	e.stopPropagation();
    },false);
    sRefreshBtn.addEventListener('tap',refreshSec,false);
	
	weixinServicesBtn.addEventListener('tap',function(event){
		app.copyText('chayueshebao2018');
		$.toast('微信号已复制到剪贴板');
		plus.runtime.openURL('weixin://');
	},false);
	g('weixinAccount').addEventListener('tap',function(event){
		app.copyText('joyshebao');
		$.toast('微信号已复制到剪贴板');
		plus.runtime.openURL('weixin://');
	},false);
	QQServicesBtn.addEventListener('tap',function(){
		app.copyText('3507448491');
		plus.runtime.openURL('mqqwpa://im/chat?chat_type=crm&uin=3507448491&version=1&src_type=web&web_src=http:://wpa.b.qq.com');
		//$.toast('QQ号已复制到剪贴板');
	},false);
	

	g('ybTip').addEventListener('tap',function(){
		plus.nativeUI.showWaiting();
		if(explanIds.med===0){
			getNounsExplanation(obj.secInfo.payCity,function(){
				showTip('ybTipBox','ybContent',explanIds.med);
			});
		}else {
			showTip('ybTipBox','ybContent',explanIds.med);
		}
	},false);
	
	g('ylTip').addEventListener('tap',function(){
		plus.nativeUI.showWaiting();
		if(explanIds.Pen===0){
			getNounsExplanation(obj.secInfo.payCity,function(){
				showTip('ylTipBox','ylContent',explanIds.Pen);
			});
		}else {
			showTip('ylTipBox','ylContent',explanIds.Pen);
		}
	},false);
	
	g('btnGetMsg').addEventListener('tap',function(){
		getMsgCode();
	},false);
	
    window.addEventListener("refresh_data",function () {
    	
    	obj.state = app.getState();
    	if(obj.state.token){
    		var nw = plus.webview.currentWebview(),
    			user = obj.state.info||{};
	 		obj.securityAcctId =  user.securityAcctId || nw.securityAcctId;
			LoadData(obj.securityAcctId);
    	}
    }, false);
	progessBar.init(document.querySelector('.mui-content'));
	scrollBox.onscroll = scrollFunc;
	mui.back = function(){
		oldBack();
	}
	var userData = app.getUser();
	obj.securityAcctId =  common.utils.queryString('securityAcctId') || userData.securityAcctId;
	obj.isRefresh = common.utils.queryString('isRefresh') == 1;
	LoadData(obj.securityAcctId);
	var showTab = common.utils.queryString('showTab');
	if(showTab) $('#slider').slider().gotoItem(showTab-1,0);
	var guideVer = myStorage.getItem("guideSecurityDetail");
	var appVer = myStorage.getItem('appver');
	
	if (guideVer != appVer) {
		myStorage.setItem("guideSecurityDetail", appVer);
		DOM.guide({
			target: document.querySelector('.change button'),
			targetStyle: {
				width: '100%',
				textAlign: 'right',
				color: '#fff',
				fontSize: '15px'
			},
			parentStyle: {
				width: '50px',
				right: '20px',
				left: 'none',
			},
			child: '<img style="width: 100%; position: fixed; top: 60px; left:0" src="../images/guide-security-detail.png"/>'
		}, true)		
	}
	window.sbkInfo = obj;
})(mui,myStorage,jscope,shebaoSvc,document);
