(function(app,req) {
	var state = app.getState();
	var svc = {};
	
	//新增：根据业务获取城市列表
	svc.getNewCityList = function (type) {
		var url = app._baseUrl + '/cityCommon/getCityList';
        return req.post(url,{buzzNum:type});
	};
	
	//咨询新回复状态
	svc.getReplyState = function () {
        var url = app._baseUrl + '/consultService/getReplyState';
        return req.get(url);
   	};
   	
   	//综合用户业务状态
	svc.getPersonInfo = function () {
		var url = app._baseUrl + '/personCenter/getPersonInfo';
    	return req.get(url);
	};

	svc.getSecNum = function(){
		var url = app._baseUrl + '/pool/getSecNum';
		return req.post(url,{});
	};
	svc.getFunNum = function(){
		var url = app._baseUrl + '/pool/getFunNum';
		return req.post(url,{});
	};
    svc.getUserOrderNum = function () {
        var url = app._baseUrl + '/order/getUserOrderNum';
        return req.get(url);
    };
	svc.getSwitch = function(conditions){
		var url = app._baseUrl + '/personCenter/getOpenRoot';
		return req.post(url,{conditions:conditions});
	};
	
	
	/**
	 * 获取在线客服连接平台
	 */
	svc.getCustomerInfo = function(params){
		var url = app._baseUrl + '/personCenter/getCustomerInfo';
		return req.post(url, {userid: params.userId, deviceid: params.deviceId, getuiId: params.getuiId}); 
	};
	
	svc.getMainLinks = function(osname){
		var url = app._baseUrl + '/personCenter/getNewExtentList';
		var city = app.getCity();
		return req.post(url,{os:osname,cityCode:city.cityCode});
	};
  
	svc.mainLinksCountClick = function(id){
		var url = app._baseUrl + '/personCenter/addExtentClickCount';
		return req.post(url,{serialNumber:id});
	};
  
	svc.getAppResourceUrl = function(num){
		var url = app._baseUrl + '/systemCurrent/getResources';
		return req.post(url,{resourcesNum:num});
	};
	
	/*
	101 更新社保卡
	102 更新公积金 
	103 绑定社保卡 
	104 绑定公积金 
	105 打开app 
	*/
	svc.ACTIVITY_CODE = {
		refesh_sc:101,
		refesh_fi:102,
		bind_sc:103,
		bind_fi:104,
		start_app:105
	};
	svc.getActivity = function(posId,triggerPoint,data){
		var url = app._gwMarket+'/freeInsurance/getFreeRedPackage';
		var city = app.getCity()||{};
		var user = app.getUser()||{};
 		var postData = mui.extend({},{
			adLocationId:posId,
			triggerPoint:triggerPoint,
			cityCode:city.cityCode||'000000',
			userId:user.userId,
			orgAttributionType:1,
			appid:plus.runtime.appid
		},data);
		return req.post(url,postData);
	};
	
	//获取综合搜索分类
	svc.getAllNavigation = function(){
		var url = app._gwCons + '/navi/getAllNavigation';
		return req.get(url);
	};
	//搜索全部类型结果
	svc.searchAllNav = function(keywords){
		var url = app._gwCons + '/navi/homeSearch/'+keywords;
		return req.get(url);
	};
	//搜索分类结果
	svc.searchTypeNav = function(data){
		var url = app._gwCons + '/navi/naviSearch';
		return req.post(url,data);
	};

	svc.getContacts = function(pageId){
		var url = app._gwUser + '/system/KfMobiles';
		return req.post(url,{mlLocationId:pageId});
	};
	
	//春雨医生H5页面跳转连接
	svc.connectionRequest = function(){
		var url=app._gwCoop+'/chunyu/getLoginUrl';
		return req.get(url);
	}
	//春雨医生未读信息请求接口
	svc.replyNumRequest = function(){
		var url=app._gwCoop+'/chunyu/getReplyNum';
		return req.get(url);
	}
	
	window.appSvc=svc;
})(app,request);