/**
 * Created by tuchl on 2016-06-23.
 */
(function($,myStorage,common,app,userSvc) {
	var obj = {};
	
	obj.auths = {};
	obj.hasOauths = true;

	obj.setAuths = function(successBack,errorBack){
		successBack = successBack || $.noop;
		errorBack = errorBack || $.noop;
		plus.oauth.getServices(function(services) {
			for (var i in services) {
				var service = services[i];
				obj.auths[service.id] = service; 
			}
			successBack(obj.auths);
		}, function(error) {
			auth.hasOauths = false;
			errorBack(error);
		});
	};

    obj.getOauthUser = function(oauth){
    	var type = oauth.id;
		var oauthUser = {};
		if(type == 'weixin'){
			oauthUser= {
				thirdType:oauth.id,
				openId:oauth.authResult.openid,
				nickname:oauth.userInfo.nickname,
				head:oauth.userInfo.headimgurl,
				weiBoPath:''
			};
		}else if(type == 'qq'){
			oauthUser= {
				thirdType:oauth.id,
				openId:oauth.authResult.openid,
				nickname:oauth.userInfo.nickname,
				head:oauth.userInfo.figureurl,
				weiBoPath:''
			};
		}else if(type == 'sinaweibo'){
			oauthUser= {
				thirdType:oauth.id,
				openId:oauth.authResult.uid,
				nickname:oauth.userInfo.name,
				head:oauth.userInfo.avatar_hd,
				weiBoPath:oauth.userInfo.url
			};
		}
		return oauthUser;
    };

 	window.auth= obj;

})(mui,myStorage,common,app,userSvc);