(function(e, t) {
	app.mui = t;
	app.platform = {
		android: t.os.android,
		ios: t.os.ios,
		iphoneX: ((function(){
    		return /iphone/gi.test(navigator.userAgent) && ((screen.height == 812 && screen.width == 375) || (screen.height == 896 && screen.width == 414))
		})())
	};
	app.getStyle = function (ele,pclass) {
	    var style = ele.style;
	    if(window.getComputedStyle) {
	        style = window.getComputedStyle(ele, pclass);
	    }else if(ele.currentStyle){
	        style = ele.currentStyle;
	    }
	    return style;
	};
	app.immersend = (function() {
		var barH = myStorage.getItem("imBarH");
		function t(iHight) {
			var headers = mui(".mui-bar");
			var muiScroll = null;
			var iPaddingBottom = 0;
			var cont = null;
			var iPadding = 0;
			var headerHigh;
			if (headers) {
				mui.each(headers, function(i, header){
					headerHigh = 44 + iHight;
					header.style.height = headerHigh + "px";
					header.style.paddingTop = iHight + "px";
					var middleDom = header.nextElementSibling;
					if (!middleDom.classList.contains('mui-content')) {
//						middleDom.style.top = headerHigh + 'px';
						headerHigh += middleDom.offsetHeight
					}
					cont = header.parentNode.querySelector('.mui-content');
					if (cont) {
						// 兼容iphoneX
//						if (app.platform.iphoneX) {
//							 cont.style.paddingBottom =  35 + 'px';
//						}
						cont.style.paddingTop = headerHigh + "px";
					}
				})
			} else {
				
			}
			app.imbarH = barH;
			app.headerH = barH + 40;
			mui.plusReady(function(){
				if (window.plus) {
					let oView = plus.webview.currentWebview();
					if (oView.backViewBarColor) {
						app.backViewBarColor = oView.backViewBarColor;
					}	
				}
			})
		}
		if (barH) {
			t(barH);
		}else {	
			mui.plusReady(function() {
				var barH = 0;
				if (plus.navigator.isImmersedStatusbar()) {
					barH = plus.navigator.getStatusbarHeight();
					
					// 兼容iphoneX
					if (app.platform.iphoneX) {
						 barH += 24;
					}
					myStorage.setItem("imBarH", barH)
					
					plus.navigator.setStatusBarStyle(mui.os.ios ? "UIStatusBarStyleDefault": "dark");
				}
				t(barH);
			})
		}
		document.addEventListener('touchmove', function(){}, false);
	} ());
	
	app.openPage = function(url, extra) {
		var loginRE = /login/;
		var configData = app.urls[url] || {};
		url = app.serialzieGetUrl(configData.url || url, extra);
		if (extra) {
			extra.backViewBarColor = window.plus && plus.navigator.getStatusBarStyle();
		} else {
			extra = {
				backViewBarColor: window.plus && plus.navigator.getStatusBarStyle()
			}
		}
		var ids = /([\w\-]*)\.html/.exec(url);
		var loginRE = /login/;
		var id = ids ? ids[1] : url;
		var oView = app.openWebview(url, id, {}, extra, false, {autoShow:true,aniShow:loginRE.test(url) ? 'slide-in-bottom' : 'slide-in-right'});
		oView.addEventListener('close', function(){
			app.backFN && app.backFN();
			if (app.backViewBarColor) {
				app.setBarStyle(app.backViewBarColor);
			}
		}, false);
		
		if (configData.barColor) {
			setTimeout(function(){
				app.setBarStyle(configData.barColor);
			}, 500)
		}
		return oView;
	};
	app.serialzieGetUrl = function(url, data) {
		let searchStr = [];
	    for (var i in data) {
	      searchStr.push(i + '=' + data[i]);
	    }
	    searchStr = searchStr.join('&');
	    if (url.indexOf('?') == -1 && searchStr) {
	      searchStr = '?' + searchStr;
	    }
	    return (url + searchStr);
	};

	app.plusReady = function(e) {
		t.plusReady(function() {
			e.bind(plus)()
		})	
	};
	app.addEventListener = function(name, callback) {
		if (app.originPlatform === 'web') {
			window.addEventListener('storage', function(res){
				var data = JSON.parse(res.newValue);
				data = data.data;
				if (res.key !== name) return;
				data = JSON.parse(data);
				callback && callback(data);
			}, false);
			myStorage.setItem(name, null);
		} else {
			window.addEventListener(name, function(res){
				let data = res ? res.detail : {};
				callback(data);
			}, false);		
		}
	};
	app.getNetType = function(e) {
		var t = !0;
		switch (plus.networkinfo.getCurrentType()) {
		case plus.networkinfo.CONNECTION_UNKNOW:
			myStorage.setItem("NetType", "UNKNOW");
			break;
		case plus.networkinfo.CONNECTION_NONE:
			myStorage.setItem("NetType", "EMPTY"),
			t = "false";
			break;
		case plus.networkinfo.CONNECTION_ETHERNET:
			myStorage.setItem("NetType", "ETHERNET");
			break;
		case plus.networkinfo.CONNECTION_WIFI:
			myStorage.setItem("NetType", "WIFI");
			break;
		case plus.networkinfo.CONNECTION_CELL2G:
			myStorage.setItem("NetType", "CELL2G");
			break;
		case plus.networkinfo.CONNECTION_CELL3G:
			myStorage.setItem("NetType", "CELL3G");
			break;
		case plus.networkinfo.CONNECTION_CELL4G:
			myStorage.setItem("NetType", "CELL4G");
			break;
		default:
			myStorage.setItem("NetType", "OTHER")
		}
		return t
	};
	app.isPlainObject = mui.isPlainObject;
	app.toast = function(msg){
		mui.toast(msg)
	}
	app.alert = mui.alert;
	app.confirm = mui.confirm;
	app.showWaiting = function(str){
		return window.plus && plus.nativeUI.showWaiting(str);
	}
	app.closeWaiting = function(){
		return window.plus && plus.nativeUI.closeWaiting();
	}
	app.isEmptyObject = mui.isEmptyObject;
	app.extend = mui.extend;
	app.setBarStyle = function(param){
		mui.plusReady(function(){
			if (plus.navigator.isImmersedStatusbar()) {
				if ('light' === param) {
					plus.navigator.setStatusBarStyle('light');
				} else if('dark' === param) {
					plus.navigator.setStatusBarStyle('dark');
				} else {
					plus.navigator.setStatusBarStyle(param);
				}
			}
		})
		
	}
	app.getBarStyle = function(){
		return plus.navigator.getStatusBarStyle();
	}
	window.addEventListener('back', function(data){
		data = data.detail;
		app.backViewBarColor = data[data.length-1];
		app.backFN = function(){
			for (let i = 0; i < data.length; i ++) {
				let item = data[i];
				if (app.isPlainObject(item)) {
					app.fireEvent(item.viewId, item.eventName, item.data);	
				}
			}
		}
	}, false);
	app.listenerBack = function(data){
		var back = mui.back;
		if (app.originPlatform === 'web') {
			mui.back = function(){
				for (let i = 0; i < data.length; i ++) {
					let item = data[i];
					if (app.isPlainObject(item)) {
						app.fireEvent(item.viewId, item.eventName, item.data);	
					}
				}
				back();
			};
		} else {
			mui.plusReady(function(){
				let curView = plus.webview.currentWebview();
				let opener = curView.opener();
				if (data) {
					data.push(curView.backViewBarColor);
				} else {
					data = [curView.backViewBarColor];
				}
				if (opener) {
					mui.fire(opener, 'back', data);
				}
			})	
		}
		app.back = mui.back;
	}
	app.listenerBack();
} (window, mui));